library proxy;

uses
  SysUtils,
  Classes,
  windows,
  libiscsi in '..\..\libiscsi-delphi\libiscsi.pas';

{$R *.res}

type
  dllread_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllwrite_proc = function (handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
  dllclose_proc = function (handle:thandle): integer; cdecl;

var
file_handle:thandle;
lun:integer;


//function SetFilePointerEx (hFile: THandle; lDistanceToMove: int64; lpNewFilePointer: Pointer; dwMoveMethod: DWORD): BOOL; stdcall; external 'kernel32.dll';
//function GetFileSizeEx(hFile: THandle; var lpFileSize: Int64): BOOL; stdcall; external 'kernel32.dll' name 'GetFileSizeEx';

function Swap16(ASmallInt : SmallInt) : SmallInt ; register ;
 asm  xchg al,ah  end ;

function Swap32(value : dword) : dword ; assembler ;
  asm  bswap eax  end ;

function my_read_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
var
task:pointer;
bytesread,lun,status:integer;
lba:int64;
ptr:dword;
begin
  result:=-1;

	writeln('Read request - size:'+inttostr(size)+' offset:'+inttostr(offset));
  //
  {
  if iscsi_is_logged_in(iscsi)<>1 then
  begin
  writeln('trying to reconnect...');
  if iscsi_reconnect_sync(iscsi)<>0 then writeln('reconnect failed '+strpas(iscsi_get_error(iscsi)));
  result:=-1;
  exit;
  end;
  }
  //
  lun:=Piscsi_url(url)^.lun ;
  lba:= offset div block_size ;
  //writeln(lun);  writeln(lba); writeln(block);
  status:=read16(lun,lba,size,buf,bytesread);
  if status=0
    then result:=bytesread
    else writeln('error:'+strpas(iscsi_get_error(iscsi)));
end;

function my_write_proc(handle:thandle; buf:pointer; size:cardinal; offset:int64): integer; cdecl;
var
lun,status,byteswritten,total:integer;
lba,max:int64;
ptr:dword;
begin
  result:=-1;
  max:=256*1024;
  writeln('Write request - size:'+inttostr(size)+' offset:'+inttostr(offset));
  //
  {
  if iscsi_is_logged_in(iscsi)<>1 then
  begin
  writeln('trying to reconnect...');
  iscsi_reconnect_sync(iscsi);
  result:=-1;
  exit;
  end;
  }  
  //
  lun:=Piscsi_url(url)^.lun ;
  lba:= offset div block_size ;
  //writeln(lun);  writeln(lba); writeln(block);
  //we need to split the data into 256KB max chunks otherwise most iscsi targets will crash
  ptr:=dword(buf);
  total:=0;
  while ptr<dword(buf)+size do
  begin
  if ptr+max>dword(buf)+size then max:=(dword(buf)+size)-ptr;
  //writeln(inttostr(offset)+'->'+inttostr(max));
  status :=write16(lun,lba,pointer(ptr),max,byteswritten);
  if status=0
    then total:=total+byteswritten
    else
    begin
    writeln('error:'+strpas(iscsi_get_error(iscsi)));
    exit;
    //break;
    end;
  ptr:=ptr+max;
  offset:=offset+max;
  lba:= offset div block_size ;
  end;
  result:=total;

end;

function my_close_proc(handle:thandle): integer; cdecl;
begin
	writeln('Close request');
  //
  if iscsi =nil then exit;
  //
  if url<>nil then iscsi_destroy_url(url);
  iscsi_disconnect(iscsi);
  //
  iscsi_destroy_context(iscsi);
  iscsi:=nil;
  //lib_free;
	result:=0;
end;

//filename = iscsi://192.168.1.144/iqn.2008-08.com.starwindsoftware:erwan-pc2-test2/0
function dllopen(filename:pchar; read_only:integer; var dllread:dllread_proc; var dllwrite:dllwrite_proc; var dllclose:dllclose_proc; var size:int64):thandle;cdecl;
var
portal,target:pchar;
ret:integer;
begin
result:=0;

	writeln('File to open: '+filename);

	dllread := my_read_proc;
	dllwrite := my_write_proc;
	dllclose := my_close_proc;

  //
  init;
  //
  if iscsi=nil then iscsi := iscsi_create_context('iqn.2007-10.com.github:erwan');

  if iscsi_is_logged_in(iscsi)=1 then
  begin
  raise exception.create('please disconnect first');
  exit;
  end;

  //iscsi_set_log_level(iscsi,10);
  //iscsi_set_log_fn(iscsi,@iscsi_log_to_stderr);
  //
  url := iscsi_parse_full_url(iscsi, filename);

  portal:=Piscsi_url(url)^.portal ;
  target:=Piscsi_url(url)^.target ;
  lun:=Piscsi_url(url)^.lun ;

  if iscsi_set_targetname(iscsi,target )<>0 then writeln('iscsi_set_targetname failed');
  if iscsi_set_session_type(iscsi, ISCSI_SESSION_NORMAL)<>0 then writeln('iscsi_set_targetname failed');
  if iscsi_set_header_digest(iscsi, ISCSI_HEADER_DIGEST_CRC32C_NONE)<>0 then writeln('iscsi_set_targetname failed');
  //
  iscsi_set_noautoreconnect(iscsi,0);
  iscsi_set_reconnect_max_retries(iscsi,3);
  //will connect to the portal, login, and verify that the lun is available
  ret:=iscsi_full_connect_sync (iscsi,portal,lun);
  if ret<>0 then
  begin
  writeln(strpas(iscsi_get_error(iscsi)));
  exit;
  end;
  //
if readcapacity10(lun)<>0 then
  begin
  writeln(strpas(iscsi_get_error(iscsi)));
  exit;
  end;

size:=((total_lba)+1)*(block_size) ;  

result:=1; //fake...
end;

exports
  dllopen index 1;

begin
end.
